Name:          AdaptiveCpp
Version:       24.10.0
Release:       1%{?dist}
Summary:       Multi-backend implementation of SYCL for CPUs and GPUs

License:       BSD
URL:           https://github.com/AdaptiveCpp/AdaptiveCpp
Source0:       %{url}/archive/v%{version}/%{name}-%{version}.tar.gz
Patch1:        0001-lib64-install-fixes.patch

ExcludeArch: %{ix86}
BuildRequires: cmake
BuildRequires: boost-devel
BuildRequires: libedit-devel
BuildRequires: libxml2-devel
BuildRequires: python3-devel
BuildRequires: zlib-devel
BuildRequires: zstd
# LLVM optimised CPU support
BuildRequires: clang-devel
BuildRequires: llvm-devel
BuildRequires: libomp-devel
# OpenCL support
BuildRequires: ocl-icd

%description
AdaptiveCpp, formerly Open SYCL, formerly hipSYCL, is a modern platform for
C++-based heterogeneous programming models targeting CPUs and GPUs from all
major vendors. Currently, AdaptiveCpp supports the following programming models:

1) SYCL: At its core is a SYCL implementation that supports many use cases
and approaches of implementing SYCL.
2) C++ standard parallelism: Additionally, AdaptiveCpp features experimental
support for offloading C++ algorithms from the parallel STL. See here for
details on which algorithms can be offloaded.

%package devel
Summary: Development package for %{name}
Requires: %{name}%{?_isa} = %{version}-%{release}

%description devel
Files for development with %{name}.


%prep
%autosetup -p1

%build
%cmake

%cmake_build
 ##-DWITH_OPENCL_BACKEND=ON
 ## -DACPP_COMPILER_FEATURE_PROFILE="full" \
 ## -DWITH_OPENCL_BACKEND=ON
 ## ACPP_ADAPTIVITY_LEVEL=1 ACPP_ALLOCATION_TRACKING=1
 ## --acpp-targets=generic             


%install
%cmake_install


%files
%license LICENSE
%{_bindir}/acpp
%{_bindir}/acpp-appdb-tool
%{_bindir}/acpp-hcf-tool
%{_bindir}/acpp-info
%{_bindir}/syclcc
%{_bindir}/syclcc-clang
%{_libdir}/hipSYCL/
/usr/etc/AdaptiveCpp/acpp-core.json

%files devel
%{_includedir}/AdaptiveCpp/
%{_libdir}/libacpp-*.so
%{_libdir}/cmake/AdaptiveCpp/
%{_libdir}/cmake/hipSYCL/
%{_libdir}/cmake/OpenSYCL/


%changelog
* Mon Dec 23 2024 Peter Robinson <pbrobinson@fedoraproject.org> - 24.10.0-1
- Initial version
